package org.example;

import lombok.SneakyThrows;

import java.io.UnsupportedEncodingException;
import java.security.Key;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

import javax.crypto.Cipher;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESedeKeySpec;
import javax.crypto.spec.IvParameterSpec;

/**
 * 3DES加密工具类
 */
public class AndroidDesUtil {
	// 密钥
	private final static String secretKey = "m1yanfa@seeyon.com119$#M1#$";
	private final static String iv = "01234567";
	private final static String encoding = "utf-8";

	/**
	 * DES加密
	 * @param plainText
	 *            普通文本
	 * @return
	 * @throws Exception
	 */
	public static String encode(String plainText) throws Exception {
		if (plainText == null || "".endsWith(plainText)) {
			return "";
		}
		try {
			Key deskey = null;
			DESedeKeySpec spec = new DESedeKeySpec(secretKey.getBytes());
			SecretKeyFactory keyfactory = SecretKeyFactory.getInstance("desede");
			deskey = keyfactory.generateSecret(spec);

			Cipher cipher = Cipher.getInstance("desede/CBC/PKCS5Padding");
			IvParameterSpec ips = new IvParameterSpec(iv.getBytes());
			cipher.init(Cipher.ENCRYPT_MODE, deskey, ips);
			byte[] encryptData = cipher.doFinal(plainText.getBytes(encoding));
			return Base64.encode(encryptData);
		} catch (Exception e) {
			throw new Exception(e.getLocalizedMessage());
		}
	}

	/**
	 * DES解密
	 *
	 * @param encryptText
	 *            加密文本
	 * @return
	 * @throws Exception
	 */
	public static String decode(String encryptText) throws Exception {
		try {
			if(encryptText == null){
				return "";
			}
			Key deskey = null;
			DESedeKeySpec spec = new DESedeKeySpec(secretKey.getBytes());
			SecretKeyFactory keyfactory = SecretKeyFactory.getInstance("desede");
			deskey = keyfactory.generateSecret(spec);
			Cipher cipher = Cipher.getInstance("desede/CBC/PKCS5Padding");
			IvParameterSpec ips = new IvParameterSpec(iv.getBytes());
			cipher.init(Cipher.DECRYPT_MODE, deskey, ips);
			byte[] decryptData = cipher.doFinal(Base64.decode(encryptText));
			return new String(decryptData, encoding);
		} catch (Exception e) {
			throw new Exception(e.getLocalizedMessage());
		}
	}

	public static String md5String(String inputString) {
		byte[] hash;
		try {
			hash = MessageDigest.getInstance("MD5").digest(inputString.getBytes("UTF-8"));
		} catch (NoSuchAlgorithmException var7) {
			throw new RuntimeException("Huh, MD5 should be supported?", var7);
		} catch (UnsupportedEncodingException var8) {
			throw new RuntimeException("Huh, UTF-8 should be supported?", var8);
		}

		StringBuilder hex = new StringBuilder(hash.length * 2);
		byte[] var3 = hash;
		int var4 = hash.length;

		for(int var5 = 0; var5 < var4; ++var5) {
			byte b = var3[var5];
			if ((b & 255) < 16) {
				hex.append("0");
			}

			hex.append(Integer.toHexString(b & 255));
		}

		return hex.toString();
	}

	@SneakyThrows
	public static void main(String[] args) {
		String encode = AndroidDesUtil.encode("zyx888888");
		System.out.println(encode);
		String decode = AndroidDesUtil.decode("rSF3HKzE2Q2wAcJCP6ib+g==");
		System.out.println(decode);
	}
}
