package org.example;

import com.fasterxml.jackson.databind.ObjectMapper;
import lombok.SneakyThrows;
import org.apache.commons.io.IOUtils;
import org.apache.hc.client5.http.classic.methods.HttpPost;
import org.apache.hc.client5.http.impl.classic.CloseableHttpClient;
import org.apache.hc.client5.http.impl.classic.HttpClients;
import org.apache.hc.core5.http.ContentType;
import org.apache.hc.core5.http.Header;
import org.apache.hc.core5.http.io.entity.StringEntity;
import org.apache.hc.core5.http.message.BasicHeader;

import java.io.InputStream;
import java.nio.charset.StandardCharsets;
import java.util.Random;

// 10 8,18 * * mon,tue,wed,thu,fri /opt/jdk1.8.0_211/bin/java -jar /home/zyx/jar/app.jar
public class Daka {

    private static AliyunLogger logger = new AliyunLogger();

    private static String randomStr() {
        Random random = new Random();
        StringBuilder randomNumber = new StringBuilder();
        for (int i = 0; i < 8; i++) {
            int digit = random.nextInt(10);  // generates a random integer from 0 to 9
            randomNumber.append(digit);
        }
        return randomNumber.toString();
    }


    @SneakyThrows
    public static void main(String[] args) {

        String publicKeyStr = "MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQChDzcjw/rWgFwnxunbKp7/4e8w\n" +
                "/UmXx2jk6qEEn69t6N2R1i/LmcyDT1xr/T2AHGOiXNQ5V8W4iCaaeNawi7aJaRht\n" +
                "Vx1uOH/2U378fscEESEG8XDqll0GCfB1/TjKI2aitVSzXOtRs8kYgGU78f7VmDNg\n" +
                "XIlk3gdhnzh+uoEQywIDAQAB";

        byte[] sendTime = RsaUtil.encryptByPublicKey((System.currentTimeMillis() + "").getBytes(), publicKeyStr);


        BASE64Encoder encoder = new BASE64Encoder();

        try (CloseableHttpClient client = HttpClients.createDefault()) {
            String jsessionid = getLoginCookie(client, encoder.encode(sendTime));
            daka(client, jsessionid);
        }

    }

    @SneakyThrows
    private static void daka(CloseableHttpClient client, String jsessionid) {
        HttpPost httpPost = new HttpPost("http://oa.sxtvs.com/seeyon/rest/lexmisAtt/attCommon/attApi?cmprnd=" + randomStr());

        httpPost.setHeaders(new BasicHeader("Content-Type", "application/json;charset=UTF-8"));
        httpPost.setHeaders(new BasicHeader("User-Agent", "seeyon-m3/4.2.4"));
        httpPost.setHeaders(new BasicHeader("accessm3-scheme", "http"));
        httpPost.setHeaders(new BasicHeader("sendtime", String.valueOf(System.currentTimeMillis() / 1000)));
        httpPost.setHeaders(new BasicHeader("Cookie", jsessionid + ";"));
        DakaRootParams daka = new DakaRootParams();
        ObjectMapper objectMapper = new ObjectMapper();
        String json = objectMapper.writeValueAsString(daka);

        StringEntity entity = new StringEntity(json, ContentType.APPLICATION_JSON);
        httpPost.setEntity(entity);
        String body = client.execute(httpPost, response -> {
            InputStream inputStream = response.getEntity().getContent();
            return IOUtils.toString(inputStream, StandardCharsets.UTF_8);
        });
        logger.info("data", body);
    }

    @SneakyThrows
    private static String getLoginCookie(CloseableHttpClient client, String sendTime) {
        HttpPost httpPost = new HttpPost("http://oa.sxtvs.com/seeyon/rest/m3/login/verification");

        httpPost.setHeaders(new BasicHeader("Content-Type", "application/json;charset=UTF-8"));
        httpPost.setHeaders(new BasicHeader("User-Agent", "seeyon-m3/4.2.4"));
        httpPost.setHeaders(new BasicHeader("accessm3-scheme", "http"));
        httpPost.setHeaders(new BasicHeader("sendtime", String.valueOf(System.currentTimeMillis() / 1000)));

        StringEntity entity = new StringEntity("{\"deviceCode\":\"66361943-4EBB-4474-82E1-371CD3C2F768\",\"password\":\"qwjZCXeZeUZBWcH/zHOqWQ==\",\"client\":\"iphone\",\"login_mobliephone\":\"rSF3HKzE2Q2wAcJCP6ib+g==\",\"deviceID\":\"Y04KaZ0081eL5uBHOLHzLjkw7wZDnqXJKWOszrzQV1hy6VAHCUCirUWSdZ\n" +
                "KxDosJUcvmCYTI2Rytqm62MzTFFYe3HZZUM+k55iYnzwWnpPfdHWTnAi4u+Cyb0VcIVGOBjeq7sVO/ugAq0jngW/nQHAxKnLdD2ynzj0i07eS25h4=\",\"timezone\":\"GMT+08:00\",\"sendTime\":\"" + sendTime + "\",\"name\":\"rSF3HKzE2Q2wAcJCP6ib+g==\"}", ContentType.APPLICATION_JSON);
        httpPost.setEntity(entity);

        return client.execute(httpPost, response -> {
//            InputStream inputStream = response.getEntity().getContent();
//            String body = IOUtils.toString(inputStream, StandardCharsets.UTF_8);
            for (Header header : response.getHeaders()) {
                String name = header.getName();
                if ("Set-Cookie".equals(name)) {
                    String value = header.getValue();
                    if (value.startsWith("JSESSIONID")) {
                        return value.split(";")[0];
                    }
                }
            }
            return "";
        });
    }
}
